#include "vektor.h"
#include "printer.h"
#include "parser.h"
#include "gfanapplication.h"
#include "minkowskisum.h"
#include "newtonpolytope.h"
#include "buchberger.h"
#include "wallideal.h"
#include "lp.h"

class IsMarkedGroebnerBasisApplication : public GFanApplication
{
  FieldOption theFieldOption;
public:
  const char *helpText()
  {
    return "This program checks if a set of (marked) polynomials is a Groebner basis with respect to its marking. The output is a boolean value.\n";
  }
  IsMarkedGroebnerBasisApplication()
  {
    registerOptions();
  }
  char *name()
  {
    return "_ismarkedgroebnerbasis";
  }
  int main()
  {
    lpSetSolver("cddgmp");
    FileParser P(Stdin);
    PolynomialSet g=P.parsePolynomialSet();

    bool isGroebnerBasis=isMarkedGroebnerBasis(g);

    fprintf(Stdout,isGroebnerBasis?"true\n":"false\n");
    return 0;
  }
};

static IsMarkedGroebnerBasisApplication theApplication;
