#include "parser.h"
#include "printer.h"
#include "parser.h"
#include "gfanapplication.h"


class ToLatexApplication : public GFanApplication
{
  SimpleOption optionPolynomialSet;
  SimpleOption optionPolynomialSetList;
  FieldOption theFieldOption;
public:
  const char *helpText()
  {
    return "This program converts ASCII math to TeX math. The data-type is specified by the options.\n";
  }
  ToLatexApplication():
    optionPolynomialSet("--polynomialset_","The data to be converted is a list of polynomials."),
    optionPolynomialSetList("--polynomialsetlist_","The data to be converted is a list of lists of polynomials.")
  {
    registerOptions();
  }

  char *name()
  {
    return "_tolatex";
  }

  int main()
  {
    LatexPrinter out(Stdout);
    FileParser in(Stdin);

    if(optionPolynomialSet.getValue())
      {
	out.printPolynomialSet(in.parsePolynomialSet());
      }
    else if(optionPolynomialSetList.getValue())
      {
	out.printPolynomialSetList(in.parsePolynomialSetList());
      }
    else

      {
	fprintf(Stderr,"No type specified\n");
	assert(0);
      }
    
    return 0;
  }
};

static ToLatexApplication theApplication;
